 /*
 * file      : lib_tm/lib.c
 * project   : tm
 * with      : Gtk-2
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TM - Edition des heures de travail / Edition of working hours
 * GNU General Public License
 * 
 * This file is part of TM.
 * 
 * TM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * TM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with TM.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
	#define gettext_noop(x) (x) 
#endif

#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <string.h>

#include "lib.h"


OPTIONS_COMMAND_LINE OptionsCommandLine = {
	FALSE		// gboolean	BoolVerboseMode
};


// 
// 
void libH_print_mess (char *p_mess)
{
	printf("%s", p_mess);
}
// TRUE SI LE FICHIER EXISTE SINON FALSE
//
gboolean libutils_test_file_exist (gchar *File)
{
	/*struct stat status;
	gint	    ret;
	ret = stat (File, &status);
	return (ret > -1 && S_ISREG (status.st_mode));*/
	return (g_file_test (File, G_FILE_TEST_IS_REGULAR));
}
// TRUE SI LE DOSSIER EXISTE SINON FALSE
//
gboolean libutils_test_dir_exist (gchar *File)
{
	/*struct stat status;
	gint	    ret;
	ret = stat (File, &status);
	return (ret > -1 && S_ISDIR (status.st_mode));*/
	return (g_file_test (File, G_FILE_TEST_IS_DIR));
}
// AFFICHE L ICONE A GAUCHE DANS LA BARRE DE TITRE
// 
void libutils_set_default_icone_to_win (GtkWidget *win)
{
	gchar     *LineCommand = NULL;
	GError    *error = NULL;

	LineCommand = g_strdup_printf ("%s/pixmaps/basebuild.png", PACKAGE_DATA_DIR);
	if (TRUE == libutils_test_file_exist (LineCommand)) {
		// LineCommand = g_strdup ("/home/cat/Projects/basebuild-0.0.4/pixmaps/basebuild.png");
	 	gtk_window_set_icon_from_file (GTK_WINDOW(win), LineCommand, &error);
	 	if (error) {
	 		GDK_PIXBUF_ERROR;
			g_critical ("Could not load pixbuf: %s\n", error->message);
			g_error_free (error);
		}
	}
	g_free (LineCommand);
	LineCommand = NULL;
}
// Execute WHICH Name_Prg et si 'gchar **Pathname_Prg' est non null retourne le resultat
// 
gboolean libutils_find_file (gchar *p_find_file)
{
	gchar      *PathName = NULL;
	
	if( NULL != p_find_file ) {
		if( NULL != (PathName = g_find_program_in_path( p_find_file ))) {
			g_free( PathName );	PathName = NULL;
			return( TRUE );
		}
	}
	
	return( FALSE );
}
// 
// 
size_t libutils_get_size_file (char *PathName)
{
	FILE   *fp;
	size_t  size = 0;

	if ((fp = fopen (PathName, "r"))) {
		fseek (fp, 0, SEEK_END);
		size = ftell (fp);
		fclose (fp);
	}
	return (size);
}
// 
// 
gboolean libutils_test_write( gchar *path )
{
	gboolean  BoolWriteOk = FALSE;
	FILE     *fp = NULL;
	gchar    *str = NULL;
	
	
	if( NULL != path ) {
		// SI LE NOM DE FICHIER EST ABSENT
		if( TRUE == libutils_test_dir_exist( path )) {
			str = g_strdup_printf ("%s/Dummy_tst_write_dummy.txt", path);
		}
		else {
			gchar *Dummy = g_strdup( path );
			gchar *Ptr = strrchr( Dummy, '/' );
			*Ptr = '\0';
			str = g_strdup_printf( "%s/Dummy_tst_write_dummy.txt", Dummy );
			g_free( Dummy );
			Dummy = NULL;
		}
		if (NULL != (fp = fopen (str, "w"))) {
			BoolWriteOk = TRUE;
			fclose (fp);
			g_unlink (str);
		}
		g_free (str);
		str = NULL;
	}
	// TODO: FENETRE D ALERTE POUR L UTILISATEUR
	/*
	if (BoolWriteOk == FALSE) {
		wininfo_create (
			_("Erreur choix lieu de stockage !"),
			_("   Le lieu de stockage temporaire doit pouvoir     "),
			  "\n",
			_("   etre accessible en ecriture."),
			  "\n\n",
			_("   Veuillez recommencer."),
			  "\n",
			  "");
	}
	g_print( "libutils_test_write() :: BoolWriteOk = %s\n", BoolWriteOk ? "TRUE" : "FALSE" );
	*/
	return (BoolWriteOk);
}
// 
// 
gchar *libutils_string_toupper( gchar *p_str )
{
	gchar	*Str = g_strdup( p_str );
	gchar	*Ptr = Str;
	
	while( Ptr && *Ptr ) {
		*Ptr = g_ascii_toupper( *Ptr );
		Ptr ++;
	}
	
	return( Str );
}
// 
// 
void libutils_get_path_and_name( gchar *p_PathNameFile, gchar **p_RetPath, gchar **p_RetFile )
{
	if( NULL == *p_RetPath && NULL == *p_RetFile ) {
				
		if( TRUE == libutils_test_dir_exist( p_PathNameFile )) {
			
			*p_RetPath = g_strdup( p_PathNameFile );
		}
		else {
		
			gchar *Ptr = NULL;
			
			*p_RetPath = g_strdup( p_PathNameFile );
			Ptr = strrchr( *p_RetPath, '/' );
			Ptr ++;
			*Ptr = '\0';
			
			Ptr = strrchr( p_PathNameFile, '/' );
			Ptr ++;
			*p_RetFile = g_strdup( Ptr );
		}
	}
}
#include <sys/types.h>
#include <dirent.h>
#include <stdlib.h>
#include <unistd.h>


// 
// http://www.linuxforums.org/forum/programming-scripting/40078-c-printing-linux-process-table.html
// 
guint libutils_getProcessID( gchar *p_processname )
{
	DIR	*dir_p;
	struct dirent *dir_entry_p;
	gchar	dir_name[40];		// ??? buffer overrun potential
	gchar	target_name[252];	// ??? buffer overrun potential
	gint	target_result;
	gchar	exe_link[252];
	gint	errorcount;
	gint	result;

	errorcount = 0;
	result     = 0;
	// Open /proc/ directory
	dir_p = opendir( "/proc/" );
	// Reading /proc/ entries
	while( NULL != (dir_entry_p = readdir( dir_p )) ) {
		// Checking for numbered directories 
		if( strspn( dir_entry_p->d_name, "0123456789" ) == strlen( dir_entry_p->d_name )) {
			strcpy( dir_name, "/proc/" );
			strcat( dir_name, dir_entry_p->d_name );
			// Obtaining the full-path eg: /proc/24657/ 
			strcat( dir_name, "/" );
			exe_link[0] = 0;
			strcat( exe_link, dir_name );
			// Getting the full-path of that exe link
			strcat( exe_link, "exe" );
			// Getting the target of the exe ie to which binary it points to
			target_result = readlink( exe_link, target_name, sizeof(target_name) -1 );
			if( target_result > 0 ) {
				target_name[target_result] = 0;
				// Searching for process name in the target name -- ??? could be a better search !!!
				if( strstr( target_name, p_processname ) != NULL ) {
					result = atoi( dir_entry_p->d_name );
					g_print( "getProcessID(%s) :Found. id = %d\n", p_processname, result );
					closedir( dir_p );
					return( result );
				}
			}
		}
	}
	closedir( dir_p );
	g_print( "getProcessID(%s) : id = 0 (could not find process)\n", p_processname );
	
	return( result );
}
// 
// RETOURNE LE NOMBRE DE PROCESSUS ACTIF POUR: p_NameFile
// EX:
//	if( libutils_getNbProcess( "xcfa" ) > 1 )
//	if( libutils_getNbProcess( "tm" ) > 1 )
// 
gint libutils_getNbProcess( gchar *p_NameFile )
{
	size_t 		SizeFile;
	gchar		*Buffer = NULL;
	FILE		*fp = NULL;
	gchar		**LarrbufLine = NULL;
	gchar		**LarrbufWord = NULL;
	gint		Cpt = 0;
	gchar		*CommandLine = NULL;
	gchar		*PathNameFile = NULL;
		
	if( TRUE == libutils_find_file( "pidof" ) ) {
		
		PathNameFile = g_strdup_printf( "/tmp/process_%s", p_NameFile );
		CommandLine  = g_strdup_printf( "pidof %s > %s", p_NameFile, PathNameFile );
		system( CommandLine );
		g_free( CommandLine );
		CommandLine = NULL;
		// g_print( "getpid(void) = %d\n", getpid() );
	
		if(( SizeFile = libutils_get_size_file( PathNameFile )) > 0 ) {
			if( NULL != ( fp = fopen( PathNameFile, "r" ))) {
			
				Buffer = (gchar *)g_malloc0( sizeof(gchar) * ( SizeFile +10 ));
				SizeFile = fread( Buffer, SizeFile, 1, fp );
				fclose( fp );
			
				LarrbufLine = g_strsplit( Buffer, "\n", 0 );
				g_free( Buffer );
				Buffer = NULL;
			
				LarrbufWord = g_strsplit( LarrbufLine[ 0 ], " ", 0 );
				for( Cpt = 0; LarrbufWord[ Cpt ]; Cpt++ );
			
				g_strfreev( LarrbufWord );
				LarrbufWord = NULL;
				g_strfreev( LarrbufLine );
				LarrbufLine = NULL;
			}
		}
		g_unlink( PathNameFile );
		g_free( PathNameFile );
		PathNameFile = NULL;
		
	}
	
	return( Cpt );
}
// 
// RETOURNE LE JOUR, MOIS, ANNEE ET LE NOMBRE TOTAL DE JOURS
// RETURN:
// 	gint *p_Day	1 .. 31
// 	gint *p_Month	1 .. 12
// 	gint *p_Year	year
// RETURN:
// 	gint Nombre total de jour de l'annee p_Year
// 
gint libutils_get_DMY( gint *p_Day, gint *p_Month, gint *p_Year )
{
	GDate	*DateHeap;
	gint	Ret_Day_In_Year;
	
	DateHeap = g_date_new ();
	g_date_set_time_t( DateHeap, time (NULL) );
	*p_Year  = g_date_get_year( DateHeap );
	*p_Month = g_date_get_month( DateHeap );
	*p_Day   = g_date_get_day( DateHeap );
	Ret_Day_In_Year = g_date_get_day_of_year( DateHeap );
	Ret_Day_In_Year --;
	g_date_free( DateHeap );
	return( Ret_Day_In_Year );
}
gchar	*MMonth[]={
	gettext_noop("Janvier"),
	gettext_noop("Fevrier"),
	gettext_noop("Mars"),
	gettext_noop("Avril"),
	gettext_noop("Mai"),
	gettext_noop("Juin"),
	gettext_noop("Juillet"),
	gettext_noop("Aout"),
	gettext_noop("Septembre"),
	gettext_noop("Octobre"),
	gettext_noop("Novembre"),
	gettext_noop("Decembre")
	};
	
gchar	*DDay[]={
	gettext_noop("Lundi"),
	gettext_noop("Mardi"),
	gettext_noop("Mercredi"),
	gettext_noop("Jeudi"),
	gettext_noop("Vendredi"),
	gettext_noop("Samedi"),
	gettext_noop("Dimanche")
	};
// 
// RETOURNE LE MOIS SOUS FORME DE CHAINE
// PARAM:
//	 gint p_month: 0 .. 11
// RETURN:
// 
gchar *libutils_get_str_month( gint p_month )
{
	if( p_month < 0 || p_month > 11 ) p_month = 0;
	return( (gchar *)MMonth[ p_month ] );
}
// 
// RETOURNE LE CHIFFRE DU JOUR DE LA SEMANE: 1=Lundi ... 7=Dimanche
// PARAM:
//	guint p_day:	1 .. 31
//	guint p_month:	1 .. 12
// 	guint p_year:	year
// RETURN:
// 
gint libutils_get_weekday( guint p_day, guint p_month, guint p_year )
{
	gint	Day = 1;
	GDate	*DateHeap;
	
	DateHeap = g_date_new ();
	g_date_set_year( DateHeap, p_year );
	g_date_set_month( DateHeap, p_month );
	g_date_set_day( DateHeap, p_day );
	Day = g_date_get_weekday( DateHeap );
	g_date_free( DateHeap );
	return( Day );
}
// 
// RETOURNE LE JOUR SOUS FORME DE CHAINE
// PARAM:
//	guint p_day:	1 .. 31
//	guint p_month:	1 .. 12
// 	guint p_year:	year
// RETURN:
// 
gchar *libutils_get_str_weekday( guint p_day, guint p_month, guint p_year )
{
	gint	Day = 1;
	GDate	*DateHeap;
	
	DateHeap = g_date_new ();
	g_date_set_year( DateHeap, p_year );
	g_date_set_month( DateHeap, p_month );
	g_date_set_day( DateHeap, p_day );
	Day = g_date_get_weekday( DateHeap );
	g_date_free( DateHeap );
	Day --;
	if( Day < 0 || Day > 6 ) Day = 0;
	return( (gchar *)DDay[ Day ] );
}
// 
// RETOURNE LE JOUR SOUS FORME DE CHAINE
// PARAM:
//	guint p_day:	0 .. 7
// RETURN:
// 
gchar *libutils_get_day( gint p_day )
{
	if( p_day < 0 || p_day > 6 ) p_day = 0;
	return( (gchar *)DDay[ p_day ] );
}
// 
// RETOURNE LE NOMBRE TOTAL DE JOURS DANS L'ANNEE PASSE EN PARAMETRE
// PARAM:
//	guint p_year:	annee
// RETURN:
//	gint Nombre total de jours
// 
gint libutils_get_nbr_days_of_year( guint p_year )
{
	gint	days_of_year = 0;
	GDate	*DateHeap;
	
	DateHeap = g_date_new ();
	g_date_set_year( DateHeap, p_year );
	g_date_set_month( DateHeap, 12 );
	g_date_set_day( DateHeap, 31 );
	days_of_year = g_date_get_day_of_year( DateHeap );
	g_date_free( DateHeap );
	return( days_of_year );
}
// 
// RETOURNE NOMBRE DE JOUR DU MOIS p_month DE L'ANNEE p_year
// PARAM:
//	guint p_month
//	guint p_year
// RETURN:
//	guint Nombre de jours dans le mois
// 
guint libutils_get_days_in_month( guint p_month, guint p_year )
{
	GDate	*DateHeap;
	guint	NbrMonth;
	
	DateHeap = g_date_new ();
	g_date_set_year( DateHeap, p_year );
	g_date_set_month( DateHeap, p_month );
	g_date_set_day( DateHeap, 1 );
	NbrMonth = g_date_get_days_in_month( p_month, p_year );
	g_date_free( DateHeap );
	return( NbrMonth );

}
// 
// Retourne DEBUT et FIN de p_month et p_year en quantieme dans l'interval: 0 .. NBR_JOURS_ANNEE
// 
void libutils_get_base_days_in_month( guint p_month, guint p_year, gint *p_begin, gint *p_end )
{
	GDate	*DateHeap;
	
	// FIXER ANNEE MOIS JOUR
	DateHeap = g_date_new ();
	g_date_set_year( DateHeap, p_year );
	g_date_set_month( DateHeap, p_month +1 );
	g_date_set_day( DateHeap, 1 );
	*p_begin = g_date_get_day_of_year( DateHeap );
	*p_end = *p_begin + g_date_get_days_in_month( p_month +1, p_year );
	(*p_begin) --;
	(*p_end) --;
	g_date_free( DateHeap );
}
// 
// NUMERO DE LA SEMAINE POUR UNE DATE
// 
// guint p_day    1 .. 31
// guint p_month  1 .. 12
// guint p_year   0 .. xxx	VarEdit.YearEdit
// 
guint libutils_get_weeks( guint p_day, guint p_month, guint p_year )
{
	GDate	*DateHeap;
	guint	RetDay;
	
	DateHeap = g_date_new ();
	g_date_set_year( DateHeap, p_year );
	g_date_set_month( DateHeap, p_month );
	g_date_set_day( DateHeap, p_day );
	RetDay = g_date_get_iso8601_week_of_year( DateHeap );
	// g_print( "ANNEE %d\n", p_year );
	// g_print( "g_date_get_iso8601_week_of_year() = %d\n", NBR);
	g_date_free( DateHeap );
	
	return( RetDay );

}


















